
DROP TABLE Partida_Ambiente;



DROP TABLE CartaAmbiente;



DROP TABLE Ameba;



DROP TABLE Espaco;



DROP TABLE Jogador_Jogada;



DROP TABLE Jogada;



DROP TABLE Tipo_Jogada;



DROP TABLE Jogador_Partida;



DROP TABLE CartaGene;



DROP TABLE Tipo_Gene;



DROP TABLE Partida;



DROP TABLE Jogador;


CREATE TABLE Ameba
(
	cod_ameba            INTEGER NOT NULL AUTO_INCREMENT,
	cod_jogadorpartida   INTEGER NOT NULL,
	numero               INTEGER NULL,
	cor                  INTEGER NULL,
	cod_espaco           INTEGER NULL,
	pontoPrejudicial     INTEGER NULL,
	estaTabuleiro	     BOOLEAN NULL,
	PRIMARY KEY (cod_ameba)

);


CREATE TABLE CartaAmbiente
(
	cod_ambiente         INTEGER NOT NULL,
	camadaozonio         INTEGER NULL,
	direcao              CHAR(1) NULL,
        PRIMARY KEY (cod_ambiente)
);





CREATE TABLE CartaGeneJogador
(
	cod_jogadorpartida   INTEGER NOT NULL,
	cod_tipogene         INTEGER NOT NULL,
	PRIMARY KEY (cod_jogadorpartida,cod_tipogene)
);




CREATE TABLE Espaco
(
	cod_espaco           INTEGER NOT NULL AUTO_INCREMENT,
	cod_partida	     INTEGER NOT NULL,
	x              	     INTEGER NULL,
	y		     INTEGER NULL,
	nutriente1           INTEGER NULL,
	nutriente2           INTEGER NULL,
	nutriente3           INTEGER NULL,
	nutriente4           INTEGER NULL,
	PRIMARY KEY (cod_espaco)
);




CREATE TABLE Jogada
(
	complemento          TEXT NULL,
	cod_jogada           INTEGER NOT NULL AUTO_INCREMENT,
	cod_tipojogada       INTEGER NOT NULL,
	PRIMARY KEY (cod_jogada)
);




CREATE TABLE Jogador
(
	cod_jogador          INTEGER NOT NULL AUTO_INCREMENT,
	nome                 VARCHAR(300) NULL,
	senha                VARCHAR(8) NULL,
	ultimoAcesso         TIMESTAMP NULL,
	PRIMARY KEY (cod_jogador)
);




CREATE TABLE Jogador_Jogada
(
	cod_jogadorjogada    INTEGER NOT NULL AUTO_INCREMENT,
	cod_jogada           INTEGER NOT NULL,
	cod_jogadorpartida   INTEGER NOT NULL,
	PRIMARY KEY (cod_jogadorjogada)
);




CREATE TABLE Jogador_Partida
(
	cod_jogador          INTEGER NOT NULL,
	cod_partida          INTEGER NOT NULL,
	pontototal           INTEGER NULL,
	pontobiologico       INTEGER NULL,
	cor                  INTEGER NULL,
	cod_jogadorpartida   INTEGER NOT NULL AUTO_INCREMENT,
	PRIMARY KEY (cod_jogadorpartida)
);




CREATE TABLE Partida
(
	vez                  INTEGER NULL,
	cod_partida          INTEGER NOT NULL AUTO_INCREMENT,
	rodada               INTEGER NULL,
	data                 TIMESTAMP NULL,
	estado               BOOLEAN NULL,
	fase                 INTEGER NULL,
	duracao		     LONG NULL,
	vencedor	     INTEGER NULL,	
 	PRIMARY KEY (cod_partida)
);

 


CREATE TABLE Partida_Ambiente
(
	cod_partidaambiente  INTEGER NOT NULL AUTO_INCREMENT,
	cod_partida          INTEGER NOT NULL,
	cod_ambiente         INTEGER NOT NULL,
	PRIMARY KEY (cod_partidaambiente)
);




CREATE TABLE Tipo_Gene
(
	cod_tipogene         INTEGER NOT NULL,
	nome                 VARCHAR(200) NULL,
	preco                INTEGER NULL,
	pontoMutacao         INTEGER NULL,
 	PRIMARY KEY (cod_tipogene)
);




CREATE TABLE Tipo_Jogada
(
	cod_tipojogada       INTEGER NOT NULL AUTO_INCREMENT,
	nome                 VARCHAR(200) NULL,
	PRIMARY KEY (cod_tipojogada)
 
);








ALTER TABLE CartaGeneJogador
ADD FOREIGN KEY R_11 (cod_tipogene) REFERENCES Tipo_Gene (cod_tipogene);


ALTER TABLE CartaGeneJogador
ADD FOREIGN KEY R_16 (cod_jogadorpartida) REFERENCES Jogador_Partida (cod_jogadorpartida);


ALTER TABLE Jogada
ADD FOREIGN KEY R_9 (cod_tipojogada) REFERENCES Tipo_Jogada (cod_tipojogada);



ALTER TABLE Jogador_Jogada
ADD FOREIGN KEY R_6 (cod_jogadorpartida) REFERENCES Jogador_Partida (cod_jogadorpartida);



ALTER TABLE Jogador_Jogada
ADD FOREIGN KEY R_8 (cod_jogada) REFERENCES Jogada (cod_jogada);



ALTER TABLE Jogador_Partida
ADD FOREIGN KEY R_2 (cod_jogador) REFERENCES Jogador (cod_jogador);



ALTER TABLE Jogador_Partida
ADD FOREIGN KEY R_3 (cod_partida) REFERENCES Partida (cod_partida);




ALTER TABLE Partida_Ambiente
ADD FOREIGN KEY R_4 (cod_partida) REFERENCES Partida (cod_partida);



ALTER TABLE Partida_Ambiente
ADD FOREIGN KEY R_5 (cod_ambiente) REFERENCES CartaAmbiente (cod_ambiente);


ALTER TABLE Espaco
ADD FOREIGN KEY R_15 (cod_partida) REFERENCES Partida (cod_partida);


ALTER TABLE Ameba
ADD FOREIGN KEY R_12 (cod_jogadorpartida) REFERENCES Jogador_Partida (cod_jogadorpartida);


ALTER TABLE Ameba
ADD FOREIGN KEY R_14 (cod_espaco) REFERENCES Espaco (cod_espaco);


