/*Maysa Macedo- maysa ( at) ime.usp.br*/

/*classe que faz comunicacao entre cliente e servidor*/

import bancodados.PrimordialSoupDAO;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import primordialsoupservidor.Jogador;


public class ControladorPartidaServidor extends UnicastRemoteObject implements ControladorRemote{

 public ControladorPartidaServidor() throws RemoteException {
     super();
  }


 public  ArrayList<PartidaAbertaTO>  getPartidasEmAberto(String nome,String senha, Integer opcaologin) throws RemoteException{
     Jogador jogador = new Jogador();
     jogador.setNome(nome);
     jogador.setOpcaoLogin(opcaologin);
     jogador.setSenha(senha) ;

    
     return GerentePartida.getInstance().getPartidasAbertas(jogador);
             //so buscar

 }

    public CenarioTO logar(JogadorTO to) throws RemoteException {
        Jogador jogador = new Jogador(to.getNome(), to.getSenha());
        if (to.getOpcaoLogin() == 1) {
            try {
                PrimordialSoupDAO dao = new PrimordialSoupDAO();
                if (dao.getJogador(to.getNome(), to.getSenha()) == null) {
                    dao.adicionaJogador(jogador);
                    jogador = dao.getJogador(to.getNome(), to.getSenha());
                    return GerentePartida.getInstance().adicionarJogador(jogador);
                }
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        } else if (to.getOpcaoLogin() == 2) {
            try {
                PrimordialSoupDAO dao = new PrimordialSoupDAO();
                jogador = dao.getJogador(to.getNome(), to.getSenha());
                if (jogador != null) {
                    jogador.setUltimoAcesso(jogador.getTimestamp());

                    return GerentePartida.getInstance().adicionarJogador(jogador);

                }
            } catch (SQLException ex) {
               ex.printStackTrace();
            }
        }
        return null;

    }



  public CenarioTO atualizarCenario(Integer codPartida, Long tempo) throws RemoteException{
        return GerentePartida.getInstance().atualizaCenario(codPartida);
     
  }

  public CenarioTO reiniciarPartida(Integer codPartida) throws RemoteException{
      return GerentePartida.getInstance().reiniciarPartida(codPartida);

  }

  public CenarioTO interromperPartida(Integer codPartida, Integer codJogador) throws RemoteException{
      return GerentePartida.getInstance().interromperPartida(codPartida, codJogador);

  }
   public CenarioTO enviarDado(Integer codPartida, Integer codJogador, Integer valorDado) throws RemoteException{
      return GerenteJogo.getInstance().registrarDado(codPartida, codJogador, valorDado);

  }
  public Integer jogar2Dado() throws RemoteException{
         return GerenteJogo.getInstance().jogar2Dado();

  }
  public Integer jogar1Dado() throws RemoteException{
         return GerenteJogo.getInstance().jogar1Dado();

  }
  public CenarioTO escolherMarcador(Integer codPartida, Integer codJogador, Integer cor, Integer posicao) throws RemoteException{
      return GerenteJogo.getInstance().escolherMarcador(codPartida, codJogador, cor, posicao);

  }

  public Integer[][] escolherEspaco(Integer codPartida, Integer codJogador) throws RemoteException{
   return GerenteJogo.getInstance().escolherEspaco(codPartida, codJogador);
  }

   public Integer[][] escolherEspaco(Integer codPartida, Integer codJogador,Integer cor)throws RemoteException{
         return GerenteJogo.getInstance().escolherEspaco(codPartida, codJogador, cor);
   }

  public CenarioTO adicionarAmeba(Integer codPartida, Integer codJogador, AmebaTO ameba, Integer x, Integer y) throws RemoteException{
      return GerenteJogo.getInstance().adicionarAmeba(codPartida, codJogador, ameba, x, y);
      
  }
   //apenas muda uma ameba de um espaco para outro
   public CenarioTO deslizarAmeba(Integer codPartida, Integer codJogador, AmebaTO ameba , Integer x1 , Integer y1, Integer x2 , Integer y2) throws RemoteException{
     return GerenteJogo.getInstance().deslizarAmeba(codPartida, codJogador, ameba, x1, y1, x2, y2);

  }

   //apenas muda uma ameba de um espaco para outro
   public CenarioTO movimentarAmeba(Integer codPartida, Integer codJogador, AmebaTO ameba , Integer x1 , Integer y1, Integer x2 , Integer y2) throws RemoteException{
     return GerenteJogo.getInstance().movimentarAmeba(codPartida, codJogador, ameba, x1, y1, x2, y2);

  }

  public CenarioTO comerNutriente(Integer codPartida, Integer codJogador,AmebaTO ameba , Integer x, Integer y, EspacoTO espaco) throws RemoteException{
       return GerenteJogo.getInstance().comerNutriente(codPartida, codJogador, ameba, x, y, espaco);


  }
  public CenarioTO pagarMulta(Integer codPartida, Integer codJogador, ArrayList<CartaGeneTO> cartasGene, Integer pontoBiologico) throws RemoteException{

      return GerenteJogo.getInstance().pagarMulta(codPartida, codJogador, cartasGene, pontoBiologico);

  }
  public CenarioTO mudarParaFase2(Integer codPartida, Integer codJogador) throws RemoteException{
      
      return GerenteJogo.getInstance().mudarParaFase2(codPartida, codJogador);

  }
  public Integer calcularMulta(Integer codPartida, Integer codJogador) throws RemoteException{

      return GerenteJogo.getInstance().calcularMulta(codPartida, codJogador);

  }

  public CenarioTO mudarParaFase3(Integer codPartida, Integer codJogador) throws RemoteException{
        return GerenteJogo.getInstance().mudarParaFase3(codPartida, codJogador);

  }
   public CenarioTO comprarGene(Integer codPartida, Integer codJogador,ArrayList<CartaGeneTO >cartasGene) throws RemoteException{

       return GerenteJogo.getInstance().comprarGene(codPartida, codJogador, cartasGene);

  }

  public CenarioTO mudarParaFase4(Integer codPartida, Integer codJogador) throws RemoteException{
        return GerenteJogo.getInstance().mudarParaFase4(codPartida, codJogador);

  }
  public CenarioTO mudarParaFase5(Integer codPartida, Integer codJogador) throws RemoteException{
        return GerenteJogo.getInstance().mudarParaFase5(codPartida, codJogador);

  }
  public CenarioTO calcularPontuacao(Integer codPartida, Integer codJogador) throws RemoteException{
        try {
            return GerenteJogo.getInstance().calcularPontuacao(codPartida, codJogador);
        } catch (SQLException ex) {
            Logger.getLogger(ControladorPartidaServidor.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;

  }
  public ArrayList<HistoricoTO> requisitarHistorico(Integer codJogador) throws RemoteException{
        try {
            return GerenteHistorico.getInstance().solicitarHistorico(codJogador);
        } catch (SQLException ex) {
            Logger.getLogger(ControladorPartidaServidor.class.getName()).log(Level.SEVERE, null, ex);
        }
       return null;

  }
   public VencedorTO requisitarVencedores() throws RemoteException{
        try {
            return GerenteVencedor.getInstance().solicitarVencedor();
        } catch (SQLException ex) {
            Logger.getLogger(ControladorPartidaServidor.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
  }


   public void  fecharPartida(Integer codPartida) throws RemoteException{

      GerentePartida.getInstance().fecharPartida(codPartida);

   }

  
}