/*Maysa Macedo- maysa ( at) ime.usp.br*/

/*Interface entre o cliente e o servidor*/
/* esses métodos estão implementados na classe ControladorPartidaServidor*/

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.ArrayList;



public interface ControladorRemote extends Remote {

    public CenarioTO logar(JogadorTO jogador)throws RemoteException;

    public  ArrayList<PartidaAbertaTO>  getPartidasEmAberto(String nome,String senha, Integer opcaologin) throws RemoteException;

    public CenarioTO atualizarCenario(Integer codPartida,Long tempo)throws RemoteException;

    public CenarioTO reiniciarPartida(Integer codPartida) throws RemoteException;

    public CenarioTO interromperPartida(Integer codPartida, Integer codJogador) throws RemoteException;

    public CenarioTO enviarDado(Integer codPartida, Integer codJogador, Integer valorDado) throws RemoteException;

    public Integer jogar2Dado() throws RemoteException;

    public Integer jogar1Dado() throws RemoteException;

    public CenarioTO escolherMarcador(Integer codPartida, Integer codJogador, Integer cor, Integer posicao) throws RemoteException;

    public CenarioTO adicionarAmeba(Integer codPartida, Integer codJogador, AmebaTO ameba, Integer x, Integer y) throws RemoteException;

    public Integer[][] escolherEspaco(Integer codPartida, Integer codJogador) throws RemoteException;

    public Integer[][] escolherEspaco(Integer codPartida, Integer codJogador,Integer cor)throws RemoteException;
    
    public CenarioTO deslizarAmeba(Integer codPartida, Integer codJogador,AmebaTO ameba,Integer x1, Integer y1, Integer x2, Integer y2) throws RemoteException;

    public CenarioTO movimentarAmeba(Integer codPartida, Integer codJogador,AmebaTO ameba,Integer x1, Integer y1, Integer x2, Integer y2) throws RemoteException;

    public CenarioTO comerNutriente(Integer codPartida, Integer codJogador,AmebaTO ameba , Integer x, Integer y, EspacoTO espaco) throws RemoteException;

    public CenarioTO mudarParaFase2(Integer codPartida, Integer codJogador) throws RemoteException;

    public Integer calcularMulta(Integer codPartida, Integer codJogador) throws RemoteException;

    public CenarioTO pagarMulta(Integer codPartida, Integer codJogador, ArrayList<CartaGeneTO> cartasGene, Integer pontoBiologico) throws RemoteException;

    public CenarioTO mudarParaFase3(Integer codPartida, Integer codJogador) throws RemoteException;

    public CenarioTO comprarGene(Integer codPartida, Integer codJogador, ArrayList<CartaGeneTO> cartasGene) throws RemoteException;

    public CenarioTO mudarParaFase4(Integer codPartida, Integer codJogador) throws RemoteException;

    public CenarioTO mudarParaFase5(Integer codPartida, Integer codJogador) throws RemoteException;
    
    public CenarioTO calcularPontuacao(Integer codPartida, Integer codJogador) throws RemoteException;

    public ArrayList<HistoricoTO> requisitarHistorico(Integer codJogador) throws RemoteException;

    public VencedorTO requisitarVencedores() throws RemoteException;

    public void fecharPartida(Integer codPartida) throws RemoteException;

}
