/*Maysa Macedo- maysa ( at) ime.usp.br*/

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import primordialsoupservidor.*;


/*Classe que recebe a requisicao de abertura de partida para os clientes e insere num hash*/
/*Essa classe tambem eh responsavel por transformar os dados de partida em Cenario que é um objeto de transferencia.*/
public class GerentePartida {
    private Map <Integer,Partida> partidasIniciadas;
    private Partida partidaAguardando;
    private static GerentePartida instancia = new GerentePartida();


    private  GerentePartida(){
        partidasIniciadas = new HashMap<Integer,Partida>();
        partidaAguardando = null;


    }

    public static GerentePartida getInstance(){
        return instancia;
    }


    public Partida getPartidaAguardando(){
    	return partidaAguardando;
    }

    public void setPartidaAguardando(Partida p){
    	partidaAguardando = p;
    }

    public Collection<Partida> getPartidasIniciadas(){
    	return partidasIniciadas.values();
    }
//metodo importante!
// adiciona jogador a partida. Dependendo do numero de jogadores, a partida eh iniciada.
    public CenarioTO adicionarJogador(Jogador jogador){
        int i;

          
          if (partidaAguardando == null){
                
                partidaAguardando = new Partida();
                partidaAguardando.setAtualizacaoCenario(getCalendar());
                partidaAguardando.setPartidaFechada(false);
                //pegar ultimo entre as partidas iniciadas
                Integer cod_partida = 0;
                if (partidasIniciadas.size()>0){
                    Iterator<Integer> iteradorpartida =  partidasIniciadas.keySet().iterator();
                    while(iteradorpartida.hasNext()){
                        Integer codigoMax = iteradorpartida.next();
                        if (cod_partida < codigoMax)
                             cod_partida = codigoMax;
                    }
                }
               
                
                partidaAguardando.setCodigo(cod_partida+Integer.parseInt("1"));
                PartidaAtual partidaAtual = new PartidaAtual();
                partidaAtual.setPartida(partidaAguardando);
                partidaAtual.setJogador(jogador);
                partidaAtual.setPontoBiologico(0);
                partidaAtual.setPontos(0);
                partidaAtual.EscolherCor(0);
                partidaAguardando.addPartidaAtual(partidaAtual);

          }
          else{
                  //Inicia efetivamente a partida
          if (  partidaAguardando.QuantidadeJogadores() == 3){
                LinkedList<CartaAmbiente> cartaAmbienteLista;
                
                partidaAguardando.setAtualizacaoCenario(getCalendar());
                partidaAguardando.setDataInicio(getTimestamp());
                PartidaAtual partidaAtual = new PartidaAtual();
                partidaAtual.setPartida(partidaAguardando);
                partidaAtual.setJogador(jogador);
                partidaAtual.setPontoBiologico(0);
                partidaAtual.setPontos(0);
                partidaAtual.EscolherCor(0);
                partidaAguardando.addPartidaAtual(partidaAtual);
                ArrayList<PartidaAtual> partidasAtuais = partidaAguardando.getListaPartidaAtual();
                ArrayList<Integer> ordemExecucao = new ArrayList<Integer>(); 
                
                for(i=0; i<partidasAtuais.size();i++){
                    ordemExecucao.add(partidasAtuais.get(i).getJogador().getCodigo() );                  
                }

                partidaAguardando.setOrdemExecucao(ordemExecucao);
                cartaAmbienteLista = partidaAguardando.getCartaAmbiente();
                carregarCartaAmbiente(cartaAmbienteLista);
                Collections.shuffle(cartaAmbienteLista);
                partidaAguardando.setCartaAmbienteAtual(cartaAmbienteLista.get(0));
                LinkedList<CartaGene> cartaGeneLista = new LinkedList<CartaGene>();
                carregarCatalogoGene(cartaGeneLista);
                partidaAguardando.getCatalogoCartaGene().setCartaGene(cartaGeneLista);
                              
                //adicionar espacos de cada partida
                partidasIniciadas.put(partidaAguardando.getCodigo(),partidaAguardando);
                Integer codigo = partidaAguardando.getCodigo();
                partidaAguardando.notificarJogadores();
                partidaAguardando = null;
                return toCenario(partidasIniciadas.get(codigo));
               
          }
          else{ if (  partidaAguardando.QuantidadeJogadores() == 1 || partidaAguardando.QuantidadeJogadores() == 2){
                        
                        partidaAguardando.setAtualizacaoCenario(getCalendar());
                        PartidaAtual partidaAtual = new PartidaAtual();
                        //partidaAtual.setAmebas(null);
                        partidaAtual.setPartida(partidaAguardando);
                        partidaAtual.setJogador(jogador);
                        partidaAtual.setPontoBiologico(0);
                        partidaAtual.setPontos(0);
                        partidaAtual.EscolherCor(0);
                        partidaAguardando.addPartidaAtual(partidaAtual);
                        partidaAguardando.notificarJogadores();
                        
                }
                
           }
          }
     return toCenario(partidaAguardando);

    }
    public void carregarCartaAmbiente(LinkedList<CartaAmbiente> cartasAmbienteLista){
    int i;

    
    for(i=1; i< 12; i++){
            CartaAmbiente carta =new CartaAmbiente();
            carta.setCodigo(i);
            carta.setCamaOzonio(Integer.parseInt(Messages.getString("CAMADAOZONIO"+ i)));
            carta.setDirecao(Integer.parseInt(Messages.getString("DIRECAO"+ i)));
            cartasAmbienteLista.add(carta);
            
    }
    

    }

    public void carregarCatalogoGene(LinkedList cartasGeneLista){
    int i;
    Integer numerocartagene = Integer.parseInt(Messages.getString("NUMEROCARTAGENE"));
   
    for(i=1;i<numerocartagene+1;i++){
        CartaGene cartagene = new CartaGene();
        cartagene.setCodigo(i);
        cartagene.setNome(Messages.getString("GENENOME"+i));
        cartagene.setPontoMutacao(Integer.parseInt(Messages.getString("GENEMUTACAO"+i)));
        cartagene.setPreco(Integer.parseInt(Messages.getString("GENEPRECO"+i)));
        cartasGeneLista.add(cartagene);
        
      }
     }

     public CenarioTO reiniciarPartida(Integer codigo){

          Partida partidaReiniciando = getPartida(codigo);
          if (partidaReiniciando != null){

                partidaReiniciando.setAtualizacaoCenario(getCalendar());
                partidaReiniciando.setPartidaAberta(false);
                partidaReiniciando.setJogadorInterruptor(null);
                partidaReiniciando.notificarJogadores();
                return toCenario(partidaReiniciando);
           }
          else return null;



    }
     public CenarioTO interromperPartida(Integer codigoPartida, Integer codigoJogador){
        Partida partida = getPartida(codigoPartida);
        partida.setPartidaAberta(true);
        partida.setJogadorInterruptor(codigoJogador);
        partida.setDataCriacaoEmMillis(new GregorianCalendar().getTimeInMillis());
        partida.notificarJogadores();
        return toCenario(partida);

     }
   
    public Calendar getCalendar(){
         Calendar calendar = new GregorianCalendar();
         Date trialTime = new Date();
         calendar.setTime(trialTime);
         return calendar;
    }

    public Timestamp getTimestamp(){
     Calendar calendar = new GregorianCalendar();
     Timestamp timeStamp = new Timestamp(calendar.getTimeInMillis());
     return timeStamp;
    }


    public  ArrayList<PartidaAbertaTO> getPartidasAbertas(Jogador jogador){
          int i;
          ArrayList<PartidaAbertaTO> partidasAbertasTO= new ArrayList<PartidaAbertaTO>();
          Partida partidaReiniciando = new Partida();
          partidaReiniciando.setAtualizacaoCenario(getCalendar());
          Iterator<Partida> iteradorpartida =  partidasIniciadas.values().iterator();
         
           while(iteradorpartida.hasNext()){
                Partida partida = iteradorpartida.next();
                if (partida.getPartidaAberta())
                    if ( partida.getJogadorInterruptor().equals(jogador.getCodigo())){
                        PartidaAbertaTO partidaAberta = new PartidaAbertaTO();
                        partidaAberta.setCodigo(partida.getCodigo());
                        partidaAberta.setDataInicio(partida.getDataInicio());
                        partidaAberta.setJogadores(null);
                        partidasAbertasTO.add(partidaAberta);

                    }


            }
          return partidasAbertasTO;
    }

   

    public Partida getPartida(Integer cod_partida){
        
           
           if (this.partidaAguardando!=null){
               if (this.partidaAguardando.getCodigo().equals(cod_partida)){
                
                return partidaAguardando;
                }
               else return partidasIniciadas.get(cod_partida);}
           else{ 
               return partidasIniciadas.get(cod_partida);

            }

    }
//transforma os dados de uma partida em cenario de transferencia para o cliente
     public CenarioTO toCenario(Partida partida){
            CenarioTO cenario = new CenarioTO();
            if (partida.getCartaAmbienteAtual()!=null){
                cenario.setCamadaOzonio(partida.getCartaAmbienteAtual().getCamaOzonio()) ;
                cenario.setDirecao(partida.getCartaAmbienteAtual().getDirecao());
            }else{
                cenario.setCamadaOzonio(0) ;
                cenario.setDirecao(0);
            }
            cenario.setPartidaFechada(partida.getPartidaFechada());
            cenario.setDataInicio(partida.getDataInicio());
            cenario.setRodada(partida.getRodada());
            cenario.setFase(partida.getFase());
            cenario.setCod_partida(partida.getCodigo());
            cenario.setVencedor(partida.getVencedor());
            cenario.setPartidaInterrompida(partida.getPartidaAberta());
            cenario.setJogadores(getJogadores(partida.getListaPartidaAtual()));
            cenario.setCartaGeneLivre(getCartaGeneLivre(partida.getCatalogoCartaGene()));
            cenario.setEspacos(getEspacos(partida.getEspacos()));
            cenario.setOrdemExecucao(partida.getOrdemExecucao());
            cenario.setAtualizacaoCenario(calendarToLong(partida.getAtualizacaoCenario()));
            
            return cenario;
    }


    public Long calendarToLong(Calendar calendar){
         Long tempo;
         tempo = calendar.getTimeInMillis();
         return tempo;
    }
     
    public Boolean estaAtrasado(Integer codPartida, Long tempo){
       
       Partida partida = getPartida(codPartida);
       if (partida!=null){
            
            if (tempo.equals(partida.getAtualizacaoCenarioMillis())){
                return false;
            }
            else{
                    return true;
                }
       }
       return false;
    }

     public CenarioTO atualizaCenario(Integer codPartida){
         Calendar calendar = new GregorianCalendar();
         Date trialTime = new Date();
         calendar.setTime(trialTime);
         Partida partida = new Partida();
         partida = getPartida(codPartida);
         partida.setAtualizacaoCenario(calendar);
         return toCenario(partida);

    }

     public Partida toPartida(CenarioTO cenario){
         return (Partida) partidasIniciadas.get(cenario.getCod_partida());
        
    }


     public ArrayList<JogadorTO> getJogadores(ArrayList<PartidaAtual> partidasAtuais) {
       
      
      
       ArrayList jogadores = new ArrayList<JogadorTO>();
       int j;
       int i;
       for ( i = 0; i < partidasAtuais.size(); i++){
          JogadorTO jogadorto = new JogadorTO();          
          jogadorto.setCor(partidasAtuais.get(i).getCor());
          jogadorto.setPontoTotal(partidasAtuais.get(i).getPontos());
          jogadorto.setPontoBiologico(partidasAtuais.get(i).getPontoBiologico());
         
          ArrayList<CartaGeneTO> cartasgeneTO =new ArrayList<CartaGeneTO>();
          for ( j = 0; j < partidasAtuais.get(i).getCartasGene().size(); j++){
              CartaGeneTO cartageneto= new CartaGeneTO();
              cartageneto.setNome(partidasAtuais.get(i).getCartasGene().get(j).getNome());
              cartageneto.setPontoMutacao(partidasAtuais.get(i).getCartasGene().get(j).getPontoMutacao());
              cartageneto.setPreco(partidasAtuais.get(i).getCartasGene().get(j).getPreco());
              cartageneto.setCodigo(partidasAtuais.get(i).getCartasGene().get(j).getCodigo());
              cartasgeneTO.add(cartageneto);
          }
          jogadorto.setCartaGeneComprada(cartasgeneTO);
          ArrayList<AmebaTO> amebasTO = new ArrayList<AmebaTO>();
          ArrayList<Ameba> amebas =null;
          amebas = partidasAtuais.get(i).getListaAmebas();
          for ( j = 0; j < amebas.size(); j++){
              AmebaTO amebato= new AmebaTO();
              amebato.setCor(amebas.get(j).getCor());
              amebato.setPontoPrejudicial(amebas.get(j).getPontoPrejudicial());
              amebato.setNumero(amebas.get(j).getNumero());
              amebato.setX(amebas.get(j).getX());
              amebato.setY(amebas.get(j).getY());
              amebato.setEstaTabuleiro(amebas.get(j).getEstaTabuleiro());
              amebasTO.add(amebato);
          }

          jogadorto.setAmebas(amebasTO);
          jogadorto.setJogadorVez(false);
          jogadorto.setNome(partidasAtuais.get(i).getJogador().getNome());
          jogadorto.setScore(0); //mudar
          jogadorto.setCodigo(partidasAtuais.get(i).getJogador().getCodigo());
          jogadorto.setSenha(partidasAtuais.get(i).getJogador().getSenha());
          jogadores.add(jogadorto);
         
        }

         return jogadores;


    }



   public EspacoTO[][] getEspacos(Espaco[][] espacosatual) {
        
        EspacoTO[][] espacos = new EspacoTO[5][5];
        int i; int j;int z;
        //Inicializacao
        for (i=0;i<espacos.length;i++)
            for(j=0;j<espacos[1].length;j++){
                EspacoTO espaco= new EspacoTO();
                espaco.setNutriente1(0);
                espaco.setNutriente2(0);
                espaco.setNutriente3(0);
                espaco.setNutriente4(0);
                espacos[i][j] = espaco;
            }
        
        for( i=0; i< espacosatual.length;i++)
            for(j=0; j< espacosatual[1].length;j++){              
              espacos[i][j].setNutriente1(espacosatual[i][j].getNutriente1()) ;
              espacos[i][j].setNutriente2(espacosatual[i][j].getNutriente2()) ;
              espacos[i][j].setNutriente3(espacosatual[i][j].getNutriente3()) ;
              espacos[i][j].setNutriente4(espacosatual[i][j].getNutriente4()) ;
              ArrayList<AmebaTO> amebasTO =new ArrayList<AmebaTO>();               
              ArrayList<Ameba> ameba = espacosatual[i][j].getAmebas();              
              if (ameba != null){                
                for (z=0; z < ameba.size();z++){                     
                    AmebaTO amebato = new AmebaTO();
                    amebato.setCor(ameba.get(z).getCor());                    
                    amebato.setPontoPrejudicial(ameba.get(z).getPontoPrejudicial());
                    amebato.setNumero(ameba.get(z).getNumero());
                    amebato.setEstaTabuleiro(ameba.get(z).getEstaTabuleiro());
                    amebato.setX(ameba.get(z).getX());
                    amebato.setY(ameba.get(z).getY());
                    amebasTO.add(amebato);
                     
                }
                espacos[i][j].setAmeba(amebasTO);
                
              }
              else espacos[i][j].setAmeba(null);

        }
        return espacos;
    }


    public ArrayList<CartaGeneTO> getCartaGeneLivre(CatalogoCartaGene catalogoCartaGene) {
      int i;
     
      ArrayList<CartaGeneTO> cartaGeneLivre = new ArrayList<CartaGeneTO>();
      LinkedList<CartaGene> catalogo = new LinkedList<CartaGene>();
      catalogo  = catalogoCartaGene.getCartaGene();
     
      if (catalogo != null){
           
       for (i=0; i< catalogo.size();i++){
         CartaGeneTO   cartaGeneto = new CartaGeneTO();
         cartaGeneto.setCodigo(catalogo.get(i).getCodigo());
         cartaGeneto.setNome(catalogo.get(i).getNome());
         cartaGeneto.setPontoMutacao(catalogo.get(i).getPontoMutacao());
         cartaGeneto.setPreco(catalogo.get(i).getPreco());
         cartaGeneLivre.add(cartaGeneto);
          
        }
      }else
          cartaGeneLivre = null;
     
      return cartaGeneLivre;
    }


    public void fecharPartida(Integer codPartida){
    	Partida partida = getPartida(codPartida);
        partida.destruirPartida();
    }
}
