/*Maysa Macedo- maysa ( at) ime.usp.br*/

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.rmi.Naming;
import java.util.Scanner;
import java.util.Timer;
import primordialsoupservidor.Partida;



public class PrimordialSoupMain {



   public PrimordialSoupMain() {
   try {
        ControladorRemote controlador = new ControladorPartidaServidor();
        Naming.rebind(Messages.getString("RMI"), controlador);
        System.out.println( "Servidor Executando..." );

     }
     catch( Exception e ) {
        System.out.println( "Trouble: " + e );
     }
  }


  public static void main(String[] args) {
      
      //INICIANDO O SERVIDOR RMI
      new PrimordialSoupMain();

      
     /////////////VERIFICADOR DE TIMEOUT/////////////////
     int timeoutPartidaAguardando = Integer.parseInt(Messages.getString("TIMEOUT_PARTIDA_PENDENTE")); //em segundos
     int timeoutPartidas = Integer.parseInt(Messages.getString("TIMEOUT_PARTIDAS_ABERTAS")); //em segundos
     int tempoParaVerificacao = 1000 * Integer.parseInt(Messages.getString("TEMPO_PARA_VERIFICACAO_TIMEOUT"));

     VerificaTimeout timeout = new VerificaTimeout(timeoutPartidaAguardando, timeoutPartidas);
     Timer time = new Timer();
     time.schedule(timeout, tempoParaVerificacao, tempoParaVerificacao);

     
     
     /////////////NOTIFICADOR DE CLIENTES/////////////////
     try {
        ServerSocket s = new ServerSocket(2222);
        while (true) {
            System.out.print("Esperando alguem se conectar...");
            Socket conexao = s.accept();
            Scanner entrada = new Scanner(conexao.getInputStream());
            int idJogador = Integer.parseInt(entrada.next());
            int idPartida =  Integer.parseInt(entrada.next());
            System.out.println(" Conectou! - idJogador="+ idJogador + "\tidPartida="+ idPartida);
            Partida p = GerentePartida.getInstance().getPartida(idPartida);
            p.adicionarAtualizarCenario(conexao, idJogador);
        }
     } catch (IOException e) {
            System.out.println("IOException: " + e);
     }


  }

}



