/*Maysa Macedo- maysa ( at) ime.usp.br*/



import java.util.Collection;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.TimerTask;
import primordialsoupservidor.Partida;

public class VerificaTimeout extends TimerTask{

    public int timeout1;
    public int timeout2;

    public VerificaTimeout(int timeout1, int timeout2){
        super();
        this.timeout1 = timeout1; //em segundos
        this.timeout2 = timeout2; //em segundos
    }

    public void run(){
         System.out.println("\n\n-------VERIFICANDO TIMEOUT-------\n");

        long tempoAtual = new GregorianCalendar().getTimeInMillis();
        long tempoDiff;
        Partida partidaAguardando = GerentePartida.getInstance().getPartidaAguardando();
        if(partidaAguardando != null){
            tempoDiff = tempoAtual - partidaAguardando.getDataCriacaoEmMillis();
            if(tempoDiff / 600 > timeout1){
                System.out.println("---->>>TIMEOUT Partida aguardadndo-------\n");
                partidaAguardando.notificarJogadores("3");
                partidaAguardando.destruirPartida();
                GerentePartida.getInstance().setPartidaAguardando(null);
            }
        }


        Collection<Partida> collectPartidas = GerentePartida.getInstance().getPartidasIniciadas();
        Iterator<Partida> cadaPartida = collectPartidas.iterator();
        while(cadaPartida.hasNext()){
            Partida p = cadaPartida.next();
            if(p.getPartidaAberta()){
                tempoDiff = tempoAtual - p.getDataCriacaoEmMillis();
                 System.out.println("---->"+ p.getDataCriacaoEmMillis());
                if(tempoDiff / 600 > timeout2){
                    System.out.println("---->>>TIMEOUT Partida abertas-------\n");
                    p.notificarJogadores("2");
                    p.destruirPartida();
                    p = null;
                    cadaPartida.remove();
                }
            }
        }
        
    }
}
