
/*Maysa Macedo- maysa ( at) ime.usp.br*/

package bancodados;



import primordialsoupservidor.*;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;


public class PrimordialSoupDAO {
 private Connection connection;

       public PrimordialSoupDAO() throws SQLException{
    	   this.connection = ConnectionFactory.getConnection();
       }

       public void adicionaJogador(Jogador jogador)throws SQLException{
                        String strsql = "insert into Jogador(nome,senha,ultimoAcesso) values (?,?,?)";
			PreparedStatement smt =  connection.prepareStatement(strsql);

			smt.setString(1,jogador.getNome());
			smt.setString(2,jogador.getSenha());
			smt.setTimestamp(3,jogador.getTimestamp());

			try{ 
                            smt.execute();
				 smt.close();
				 System.out.println("gravado");
			}catch (SQLException se) {
					   System.out.println("- nao foi possivel fazer insercao.");
					   se.printStackTrace();

			}

                        

       }
       


       public Jogador getJogador(String nome, String senha) throws SQLException{
  	   String strsql = "select * from Jogador where nome=? and senha =?";
           ResultSet rs = null;
           PreparedStatement smt = connection.prepareStatement(strsql);
           smt.setString(1, nome);
           smt.setString(2, senha);
           Jogador jogador = null;
           rs = smt.executeQuery();
           if (rs.next()) {
               jogador = new Jogador();
               jogador.setCodigo((Integer) rs.getInt("cod_jogador"));
               jogador.setNome(rs.getString("nome"));
               jogador.setSenha(rs.getString("senha"));
               jogador.setUltimoAcesso(rs.getTimestamp("ultimoAcesso"));
           }
           rs.close();
           smt.close();
           return jogador;


     }
       public Long getDiferencaData(Timestamp dataInicio)
       { Long duracao;
         Calendar data_inicial = new GregorianCalendar();
         Calendar data_final = new GregorianCalendar();
         Timestamp timeStamp = new Timestamp(data_final.getTimeInMillis());
         data_inicial.setTime(dataInicio);
         data_final.setTime(timeStamp);
         duracao = data_final.getTime().getTime() - data_inicial.getTime().getTime();
         return duracao;
       
       }
        public void insereCenarioFinal(Partida partida) throws SQLException{
                int i,j;
                Integer codPartida=0,codJogadorPartida=0, codEspaco=0;
                Integer jogadorVez =0;
                if (partida.getOrdemExecucao().size()>0)
                   jogadorVez = partida.getOrdemExecucao().get(0);
                System.out.println("insere cenario");
                String strsql          = "insert into Partida(vez,rodada,data, estado, fase, duracao, vencedor) values (?,?,?,?,?,?,?)";
   	        
   	        PreparedStatement smt  =  connection.prepareStatement(strsql);

                smt.setInt(1,jogadorVez);
                smt.setInt(2, partida.getRodada());
                smt.setTimestamp(3, partida.getDataInicio());
                smt.setBoolean(4,partida.getPartidaAberta());
                smt.setInt(5, partida.getFase());
                smt.setLong(6, getDiferencaData(partida.getDataInicio()));
                smt.setLong(7, partida.getVencedor());
                 System.out.println("insere cenario");

                try{ smt.execute();
		     smt.close();
		     System.out.println("Recebeu.");
		 }catch (SQLException se) {
		 System.out.println("- nao foi possivel fazer a selecao.");
		 se.printStackTrace();
		 System.exit(1);
		}

               String strsql2          = "select max(Partida.cod_partida) as cod_partida from Partida";
  	       ResultSet rs2           = null;
	       PreparedStatement smt2  =  connection.prepareStatement(strsql2);
                try{ rs2 = smt2.executeQuery();
                    
                     System.out.println("Executou busca.");
		}catch (SQLException se) {
		  System.out.println("- nao foi possivel fazer a selecao Max partida.");
		  se.printStackTrace();
		  System.exit(1);
		}
               while(rs2.next()){
                    codPartida = rs2.getInt("cod_partida");
               }
               rs2.close();
               smt2.close();


                for(i=0;i<partida.getEspacos().length;i++)
                     for(j=0;j<partida.getEspacos()[1].length;j++) {
                       String strsql4          = "insert into Espaco(cod_partida,x,y,nutriente1,nutriente2,nutriente3,nutriente4) values (?,?,?,?,?,?,?)";
                        
                        PreparedStatement smt4  =  connection.prepareStatement(strsql4);
                        smt4.setInt(1,codPartida);
                        smt4.setInt(2,i);
                        smt4.setInt(3, j);
                        smt4.setInt(4, partida.getEspacos()[i][j].getNutriente1());
                        smt4.setInt(5,partida.getEspacos()[i][j].getNutriente2());
                        smt4.setInt(6, partida.getEspacos()[i][j].getNutriente3());
                        smt4.setLong(7, partida.getEspacos()[i][j].getNutriente4());
                         try{ smt4.execute();
                               smt4.close();
                             System.out.println("Recebeu.");
                         }catch (SQLException se) {
                         System.out.println("- nao foi possivel fazer a insercao espaco.");
                         se.printStackTrace();
                         System.exit(1);
                        }
                  }
                ArrayList<PartidaAtual> partidasAtuais = null;
                partidasAtuais = partida.getListaPartidaAtual();
                //inserir jogadores de uma partida
                for (i=0;i<partidasAtuais.size();i++){
                     
                        String strsql3     = "insert into Jogador_Partida(cod_jogador,cod_partida,pontototal,pontobiologico,cor) values (?,?,?,?,?)";
                       
                        PreparedStatement smt3  =  connection.prepareStatement(strsql3);
                        smt3.setInt(1,partidasAtuais.get(i).getJogador().getCodigo());
                        smt3.setInt(2, codPartida);
                        smt3.setInt(3, partidasAtuais.get(i).getPontos());
                        smt3.setInt(4, partidasAtuais.get(i).getPontoBiologico());
                        smt3.setInt(5, partidasAtuais.get(i).getCor());
                        
                        try{ smt3.execute();
                             smt3.close();
                             System.out.println("Recebeu.");
                                    }catch (SQLException se) {
                                               System.out.println("- nao foi possivel fazer a insercao JogadorPartida.");
                                               se.printStackTrace();
                                               System.exit(1);
                                    }

                       String strsql32          = "select max(cod_jogadorpartida) as cod_jogadorpartida from Jogador_Partida";
                       ResultSet rs32           = null;
                       PreparedStatement smt32  =  connection.prepareStatement(strsql32);
                        try{ rs32 = smt32.executeQuery();
                             
                             System.out.println("Executou busca.");
                        }catch (SQLException se) {
                          System.out.println("- nao foi possivel fazer a selecao Max partida.");
                          se.printStackTrace();
                          System.exit(1);
                        }
                        while(rs32.next()){
                        codJogadorPartida = rs32.getInt("cod_jogadorpartida");
                        }
                       rs32.close();
                       smt32.close();


                       //inserir cartagene
                      if (partidasAtuais.get(i).getCartasGene()!=null){
                         for (j=0;j<partidasAtuais.get(i).getCartasGene().size();j++){

                            String strsql6          = "insert into CartaGeneJogador(cod_jogadorpartida,cod_tipogene) values (?,?)";
                           
                            PreparedStatement smt6  =  connection.prepareStatement(strsql6);
                            smt6.setInt(1, codJogadorPartida);
                            smt6.setInt(2, partidasAtuais.get(i).getCartasGene().get(j).getCodigo());
                            try{ smt6.execute();
                                 smt6.close();
                                 System.out.println("Recebeu.");
                                 }catch (SQLException se) {
                                                   System.out.println("- nao foi possivel fazer a insercao JogadorPartida.");
                                                   se.printStackTrace();
                                                   System.exit(1);
                                  }

                         }}
                      //


                      //inserir amebabas
                     for (j=0;j<partidasAtuais.get(i).getListaAmebas().size();j++){
                        if (partidasAtuais.get(i).getListaAmebas().get(j).getX()!=null && partidasAtuais.get(i).getListaAmebas().get(j).getY()!=null){
                           String strsql51          = "select cod_espaco from Espaco where x =? and y=? and cod_partida=?";

                            ResultSet rs51           = null;
                            PreparedStatement smt51  =  connection.prepareStatement(strsql51);
                            smt51.setInt(1, partidasAtuais.get(i).getListaAmebas().get(j).getX());
                            smt51.setInt(2, partidasAtuais.get(i).getListaAmebas().get(j).getY());
                            smt51.setInt(3, codPartida);

                            try{ rs51 = smt51.executeQuery();
                                
                                 System.out.println("Executou busca.");
                            }catch (SQLException se) {
                              System.out.println("- nao foi possivel fazer a selecao Max partida.");
                              se.printStackTrace();
                              System.exit(1);
                            }
                            while(rs51.next()){
                             codEspaco = rs51.getInt("cod_espaco");
                            }
                            smt51.close();
                            rs51.close();

                            String strsql5         = "insert into Ameba(cod_jogadorpartida,numero,cor,pontoPrejudicial,estaTabuleiro, cod_espaco) values (?,?,?,?,?,?)";
                            
                            PreparedStatement smt5  =  connection.prepareStatement(strsql5);
                            smt5.setInt(1, codJogadorPartida);
                            smt5.setInt(2, partidasAtuais.get(i).getListaAmebas().get(j).getNumero());
                            smt5.setInt(3, partidasAtuais.get(i).getListaAmebas().get(j).getCor());
                            smt5.setInt(4, partidasAtuais.get(i).getListaAmebas().get(j).getPontoPrejudicial());
                            smt5.setBoolean(5, partidasAtuais.get(i).getListaAmebas().get(j).getEstaTabuleiro());
                            smt5.setInt(6, codEspaco);
                            try{ smt5.execute();
                                 smt5.close();
                                     System.out.println("Recebeu.");
                                        }catch (SQLException se) {
                                                   System.out.println("- nao foi possivel fazer a insercao JogadorPartida.");
                                                   se.printStackTrace();
                                                   System.exit(1);
                                        }

                        }else{
                            String strsql5         = "insert into Ameba(cod_jogadorpartida,numero,cor,pontoPrejudicial,estaTabuleiro) values (?,?,?,?,?)";
                            
                            PreparedStatement smt5  =  connection.prepareStatement(strsql5);
                            smt5.setInt(1, codJogadorPartida);
                            smt5.setInt(2, partidasAtuais.get(i).getListaAmebas().get(j).getNumero());
                            smt5.setInt(3, partidasAtuais.get(i).getListaAmebas().get(j).getCor());
                            smt5.setInt(4, partidasAtuais.get(i).getListaAmebas().get(j).getPontoPrejudicial());
                            smt5.setBoolean(5, partidasAtuais.get(i).getListaAmebas().get(j).getEstaTabuleiro());
                            try{ smt5.execute();
                                 smt5.close();
                                     System.out.println("Recebeu.");
                                        }catch (SQLException se) {
                                                   System.out.println("- nao foi possivel fazer a insercao JogadorPartida.");
                                                   se.printStackTrace();
                                                   System.exit(1);
                                        }



                        }
                       
                      }


                     }

                 }



 public void adicionaCartaGene(CartaGene cartagene)throws SQLException{
                        String strsql = "insert into Tipo_Gene(cod_tipogene,nome,preco,pontoMutacao) values (?,?,?,?)";
			PreparedStatement smt =  connection.prepareStatement(strsql);

			smt.setInt(1,cartagene.getCodigo());
			smt.setString(2,cartagene.getNome());
			smt.setInt(3,cartagene.getPreco());
                        smt.setInt(4,cartagene.getPontoMutacao());
			try{ smt.execute();
				 smt.close();
				 System.out.println("gravado");
			}catch (SQLException se) {
					   System.out.println("- nao foi possivel fazer insercao.");
					   se.printStackTrace();

			}
                       

       }

  public void adicionaCartaAmbiente(CartaAmbiente cartaambiente)throws SQLException{
                        String strsql = "insert into CartaAmbiente(cod_ambiente,camadaozonio,direcao) values (?,?,?)";
			PreparedStatement smt =  connection.prepareStatement(strsql);

			smt.setInt(1,cartaambiente.getCodigo());
			smt.setInt(2,cartaambiente.getCamaOzonio());
			smt.setInt(3,cartaambiente.getDirecao());
                        try{ smt.execute();
				 smt.close();
				 System.out.println("gravado");
			}catch (SQLException se) {
					   System.out.println("- nao foi possivel fazer insercao.");
					   se.printStackTrace();

			}


       }
                
 public ArrayList<Historico> getHistorico(Integer codJogador) throws SQLException{
                ArrayList<Historico> historicoLista = new ArrayList<Historico>();

                int i=0;
                System.out.println("codigo do jogador requisitante:"+codJogador);
                
  	        String strsql          ="SELECT JogaGran.cod_jogador,JogaGran.nome, JogaPartGran.pontototal,PartidaGran.vencedor as codvencedor, "+
                                         "PartidaGran.data ,PartidaGran.duracao,PartidaGran.cod_partida,(select Jog.nome from Jogador as Jog,Partida "+
                                         " as Part where PartidaGran.vencedor=Jog.cod_jogador and Part.cod_partida = PartidaGran.cod_partida ) as "+ 
                                         " vencedor  FROM   Partida as PartidaGran,Jogador_Partida as JogaPartGran,Jogador as JogaGran where exists "+
                                         " ( SELECT * FROM  Jogador_Partida as JogaExi   WHERE    JogaExi.cod_jogador = ? and "+
                                         " JogaExi.cod_partida=JogaPartGran.cod_partida) and JogaPartGran.cod_jogador = JogaGran.cod_jogador  and   "+
                                         " PartidaGran.cod_partida = JogaPartGran.cod_partida";



                
  	        ResultSet rs           = null;
		PreparedStatement smt  =  connection.prepareStatement(strsql);
		smt.setInt(1,codJogador);
                
		
                try{ rs = smt.executeQuery();
                     System.out.println("Executou busca.");
		}catch (SQLException se) {
		  System.out.println("- nao foi possivel fazer a selecao." + smt);
		  se.printStackTrace();
		  System.exit(1);
		}

                
                Historico historico = new Historico();
                Integer codigoPartidaTemp=0;
		while(rs.next()){
                    if(codigoPartidaTemp != rs.getInt("cod_partida")) {
                        if (codigoPartidaTemp != 0) historicoLista.add(historico);
                        codigoPartidaTemp = rs.getInt("cod_partida");
                        historico = new Historico();
			historico.setData(rs.getTimestamp("data"));
			historico.setDuracao(rs.getLong("duracao"));
                        historico.setVencedor(rs.getString("vencedor"));

                     }
                    historico.getJogadores().add(rs.getString("nome"));
                    historico.getPontuacoes().add(rs.getInt("pontototal"));


                    i++;
		}
                historicoLista.add(historico);
               
		rs.close();
		smt.close();
                if (i==0)
                return null;
                else
		return historicoLista;


     }


 public Vencedor getVencedores() throws SQLException{
                Vencedor vencedor = new Vencedor();
                int i=0;
                ArrayList<String> nome = new ArrayList<String>();
                ArrayList<Integer> numeroGanhos = new ArrayList<Integer>();
  	        String strsql          ="select nome,count(*) as numeroGanhos from Partida,Jogador where Partida.vencedor=Jogador.cod_jogador group by nome order by numeroGanhos desc limit 0,10";

  	        ResultSet rs           = null;
		PreparedStatement smt  =  connection.prepareStatement(strsql);
		

                try{ rs = smt.executeQuery();
                     System.out.println("Executou busca.");
		}catch (SQLException se) {
		  System.out.println("- nao foi possivel fazer a selecao." + smt);
		  se.printStackTrace();
		  System.exit(1);
		}

		while(rs.next()){
                   
		    nome.add(rs.getString("nome"));
                    numeroGanhos.add(rs.getInt("numeroGanhos"));

                        i++;
		}
                vencedor.setNome(nome);
                vencedor.setNumeroGanhos(numeroGanhos);
		rs.close();
		smt.close();
		return vencedor;


     }


 
}
