/*Maysa Macedo- maysa ( at) ime.usp.br*/

package primordialsoupservidor;
import bancodados.PrimordialSoupDAO;
import java.io.IOException;
import java.net.Socket;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;



public class Partida {
     private Integer cod_partida;
     private Timestamp dataInicio;
     private Calendar atualizacaoCenario;
     private long dataCriacaoEmMillis;
     private CartaAmbiente cartaAmbienteAtual;
     private LinkedList<CartaAmbiente> cartaAmbiente;
     private CatalogoCartaGene catalogoCartaGene;
     private ArrayList<PartidaAtual> partidasAtuais;
     private Integer rodada;
     private Boolean partidaAberta;
     private Espaco espacos[][];
     private Integer jogadorInterruptor;
     private ArrayList<Integer>ordemExecucao;
     private Integer fase;
     private Boolean partidaFechada;
     private Integer vencedor;
     private AtualizadorCenarioServidor atualizador;

     public Partida(){
        dataCriacaoEmMillis = new GregorianCalendar().getTimeInMillis();
        rodada =0;
        dataInicio = null;
        cartaAmbienteAtual = null;
        catalogoCartaGene = new CatalogoCartaGene();
        atualizacaoCenario =  new GregorianCalendar();
        partidasAtuais = new ArrayList<PartidaAtual>();
        fase = 0;
        espacos = new Espaco[5][5] ;
        cartaAmbiente = new LinkedList<CartaAmbiente>();
        partidaAberta =false;
        ordemExecucao = null;
        vencedor =0;
        atualizador = new AtualizadorCenarioServidor();
       
        
        for (int i=0;i<espacos.length;i++)
            for(int j=0;j<espacos[1].length;j++){
                Espaco espaco= new Espaco();
                espaco.setNutriente1(0);
                espaco.setNutriente2(0);
                espaco.setNutriente3(0);
                espaco.setNutriente4(0);
                espacos[i][j] = espaco;
            }
     }

     public long getDataCriacaoEmMillis(){
         return dataCriacaoEmMillis;
     }


     public void adicionarAtualizarCenario(Socket s, Integer idJogador){
         atualizador.addSocket(s, idJogador);
     }

     public void notificarJogadores(){
        try {
            atualizador.notificarClientes("1");
        } catch (IOException ex) {
           ex.printStackTrace();
        }
     }


    public void notificarJogadores(String code){
        try {
            atualizador.notificarClientes(code);
        } catch (IOException ex) {
           ex.printStackTrace();
        }
     }

    public void destruirPartida(){
        try {
            atualizador.fecharSockets();
        } catch (IOException ex) {
            Logger.getLogger(Partida.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

     public void setDataInicio(Timestamp dataInicio){
     this.dataInicio = dataInicio;
     }

     public Timestamp getDataInicio(){
       return this.dataInicio;
     }

     public void MudarCartaAmbiente(){
        this.cartaAmbienteAtual= getCartaAmbiente().get(getRodada());
     }
      public int QuantidadeJogadores(){
       return this.getListaPartidaAtual().size();
     }
    
       public void setCodigo(Integer cod_partida){
          this.cod_partida = cod_partida;
     }
     public Integer getCodigo(){
          return this.cod_partida ;
     }

    /**
     * @return the cartaAmbienteAtual
     */
    public CartaAmbiente getCartaAmbienteAtual() {
        return cartaAmbienteAtual;
    }

     public void setCartaAmbienteAtual(CartaAmbiente carta) {
        this.cartaAmbienteAtual = carta;
    }

    /**
     * @return the cartaAmbiente
     */
    public LinkedList<CartaAmbiente> getCartaAmbiente() {
        return cartaAmbiente;
    }

    /**
     * @param cartaAmbiente the cartaAmbiente to set
     */
    public void setCartaAmbiente(LinkedList<CartaAmbiente> cartaAmbiente) {
        this.cartaAmbiente = cartaAmbiente;
    }

    /**
     * @return the catalogoCartaGene
     */
    public CatalogoCartaGene getCatalogoCartaGene() {
        return catalogoCartaGene;
    }

    /**
     * @param catalogoCartaGene the catalogoCartaGene to set
     */
    public void setCatalogoCartaGene(CatalogoCartaGene catalogoCartaGene) {
        this.catalogoCartaGene = catalogoCartaGene;
    }

  
    public Integer getRodada() {
        return rodada;
    }
  
    public void setRodada(Integer rodada) {
        this.rodada = rodada;
    }


    public ArrayList<PartidaAtual> getListaPartidaAtual() {
        return this.partidasAtuais;
    }

    public synchronized void addPartidaAtual( PartidaAtual partidaAtual) {
        this.partidasAtuais.add(partidaAtual) ;
    }
    
 
     public PartidaAtual getPartidaAtual(Integer codJogador) {
         int i;
         for(i=0; i<this.partidasAtuais.size(); i++){
            if (this.partidasAtuais.get(i).getJogador().getCodigo().equals(codJogador))
                return partidasAtuais.get(i);
         }
        return null;
    }

     public Espaco[][] getEspacos() {
        return espacos;
    }

  
    public void setEspacos(Espaco[][] espacos) {
        this.espacos = espacos;
    }
    public Calendar getAtualizacaoCenario() {

        return atualizacaoCenario;
    }

    public Long getAtualizacaoCenarioMillis() {

        return atualizacaoCenario.getTimeInMillis();
    }

    /**
     * @param atualizacaoCenario the atualizacaoCenario to set
     */
    public void setAtualizacaoCenario(Calendar atualizacaoCenario) {
            this.atualizacaoCenario = atualizacaoCenario;
    }
    /**
     * @return the jogadorInterruptor
     */
    public Integer getJogadorInterruptor() {
        return jogadorInterruptor;
    }

    /**
     * @param jogadorInterruptor the jogadorInterruptor to set
     */
    public void setJogadorInterruptor(Integer jogadorInterruptor) {
        this.jogadorInterruptor = jogadorInterruptor;
    }

    /**
     * @return the partidaAberta
     */
    public Boolean getPartidaAberta() {
        return partidaAberta;
    }

    /**
     * @param partidaAberta the partidaAberta to set
     */
    public void setPartidaAberta(Boolean partidaAberta) {
        this.partidaAberta = partidaAberta;
    }

    public Integer getJogadoresDeDado() {
          Integer contador=0;   int i;
          for (i = 0; i < partidasAtuais.size() ; i++){
               if (!partidasAtuais.get(i).getJogador().getValorDado().equals(0))
                   contador++;
          }

        return contador;
    }

    /**
     * @return the ordemExecucao
     */
    public ArrayList<Integer> getOrdemExecucao() {
        return ordemExecucao;
    }

    public void setOrdemExecucao(ArrayList<Integer> ordemExecucao) {
        this.ordemExecucao = ordemExecucao;
    }

    /**
     * @return the fase
     */
    public Integer getFase() {
        return fase;
    }

    /**
     * @param fase the fase to set
     */
    public void setFase(Integer fase) {
        this.fase = fase;
    }
    @Override
    public boolean equals(Object objeto){
    if (objeto instanceof Partida){
        Partida partida = (Partida) objeto;
        if (partida!= null && this.cod_partida.equals(partida.cod_partida))
            return true;
    }
    return false;
}

    /**
     * @return the partidaFechada
     */
    public Boolean getPartidaFechada() {
        return partidaFechada;
    }

    /**
     * @param partidaFechada the partidaFechada to set
     */
    public void setPartidaFechada(Boolean partidaFechada) {
        this.partidaFechada = partidaFechada;
    }

    /**
     * @return the vencedor
     */
    public Integer getVencedor() {
        return vencedor;
    }

    /**
     * @param vencedor the vencedor to set
     */
    public void setVencedor(Integer vencedor) {
        this.vencedor = vencedor;
    }

    /**
     * @param dataCriacaoEmMillis the dataCriacaoEmMillis to set
     */
    public void setDataCriacaoEmMillis(long dataCriacaoEmMillis) {
        this.dataCriacaoEmMillis = dataCriacaoEmMillis;
    }

    public PartidaAtual getPartidaAtualCor(Integer cor) {
         int i;
         for(i=0; i<this.partidasAtuais.size(); i++){
            if (this.partidasAtuais.get(i).getCor().equals(cor))
                return partidasAtuais.get(i);
         }
        return null;
    }

}


