/*Maysa Macedo- maysa ( at) ime.usp.br*/

package primordialsoupservidor;

import java.util.ArrayList;



public class PartidaAtual {
    private Integer pontos;
    private Integer cor;
    private Integer pontoBiologico;
    private Jogador jogador;
    private Partida partida;
    private ArrayList<Ameba> amebas;
    private ArrayList<CartaGene> cartasGene;

    public PartidaAtual(){
         
         amebas = new ArrayList<Ameba>(); 
         cartasGene = new ArrayList<CartaGene>();

    }
  
  public void AdicionarPontoBiologico(Integer pontoBP){
        this.setPontoBiologico( this.getPontoBiologico() + pontoBP);

  }
  public void EscolherCor(Integer corEscolhida){
        this.cor = corEscolhida;

  }
  public void AtualizarPontuacao(Integer ponto){
    this.pontos = this.getPontos() + ponto;

  }
   public void ComprarCartaGene(CartaGene cartaGene){
        this.getCartasGene().add(cartaGene);
   }

    /**
     * @return the pontos
     */
    public Integer getPontos() {
        return pontos;
    }
    public void setPontos(Integer pontos) {
        this.pontos = pontos;
    }
    /**
     * @return the cor
     */
    public Integer getCor() {
        return cor;
    }

    /**
     * @return the jogador
     */
    public Jogador getJogador() {
        return jogador;
    }

    /**
     * @param jogador the jogador to set
     */
    public void setJogador(Jogador jogador) {
        this.jogador = jogador;
    }

    /**
     * @return the partida
     */
    public Partida getPartida() {
        return partida;
    }

    /**
     * @param partida the partida to set
     */
    public void setPartida(Partida partida) {
        this.partida = partida;
    }

    /**
     * @return the amebas
     */
    public ArrayList<Ameba> getListaAmebas() {
        return this.amebas;
    }


    public Ameba getAmeba(Integer cor, Integer numero) {
        int i;
        for(i=0;i<amebas.size();i++){
            if (amebas.get(i).getCor().equals(cor) && amebas.get(i).getNumero().equals(numero))
                return amebas.get(i);
        }
        return null;
    }
    /**
     * @param amebas the amebas to set
     */
    public void setAmebas(ArrayList<Ameba> amebas) {
        this.amebas = amebas;
    }

    public void addAmebas(Ameba ameba) {
        this.amebas.add(ameba);
    }

    /**
     * @return the cartasGene
     */
    public ArrayList<CartaGene> getCartasGene() {
        return cartasGene;
    }

    public void setCartasGene( ArrayList<CartaGene> cartaGene) {
       this.cartasGene = cartaGene;
    }
    /**
     * @return the pontoBiologico
     */
    public Integer getPontoBiologico() {
        return pontoBiologico;
    }

    /**
     * @param pontoBiologico the pontoBiologico to set
     */
    public void setPontoBiologico(Integer pontoBiologico) {
        this.pontoBiologico = pontoBiologico;
    }

    public void debitarPontoBiologico(Integer pB) {
        this.pontoBiologico = pontoBiologico - pB;
    }

    public Integer quantidadeAmebaTabuleiro(){
     Integer contador=0;
     int i;
     for (i=0;i<amebas.size();i++){
        if (amebas.get(i).getEstaTabuleiro())
            contador = contador+1;
     }
     return contador;

    }

   public boolean temCartaAerodinamica(){
     int i;
     for (i = 0; i < cartasGene.size(); i++){
        if (cartasGene.get(i).getNome().equals("Aerodinâmica"))
           return true;
     }
     return false;

    }


    public boolean temCartaTaxaDivisao(){
     int i;
     for (i = 0; i < cartasGene.size(); i++){
        if (cartasGene.get(i).getNome().equals("Taxa Divisão"))
           return true;
     }
     return false;

    }

     public boolean temCartaEsporo(){
     int i;
     for (i = 0; i < cartasGene.size(); i++){
        if (cartasGene.get(i).getNome().equals("Esporo"))
           return true;
     }
     return false;

    }


     public boolean temCartaFrugalidade(){
     int i;
     for (i = 0; i < cartasGene.size(); i++){
        if (cartasGene.get(i).getNome().equals("Frugalidade"))
           return true;
     }
     return false;

    }
  
}